/** Realizacin de un diccionario mediante un rbol de bsqueda binaria */ 
import java.io.*;
import java.security.InvalidKeyException;
public class BinarySearchTree extends MyLinkedBinaryTree implements Dictionary{ 
    Comparador C;   // interface comparador 
    protected Position actionPos; // posicin de insercin o de padre eliminado

    public BinarySearchTree(){
        super();
    } 
    // public int size(){ return size;} 
    public int size(){return (size - 1)/2;}

    // public boolean isEmpty(){ return (size == 0);} 
    public boolean isEmpty(){ return size() == 1;}

    // mtodos auxiliares:
    /** Extraer la clave del artculo en determinado nodo del rbol. */ 
    protected Object key(Position position){ 
        return ((ItemPPR) position.element()).key();
    }        
 
    /** Extraer el elemento del artculo en determinado nodo del rbol. */ 
    protected Object element(Position position){ 
        return ((ItemPPR) position.element()).element();
    }
 
    /** Mtodo auxiliar usado por quitarElemento. */ 
    protected void swap(Position swapPos, Position remPos){
        replaceElement(swapPos, remPos.element());
    }
 
    /** mtodo aux usado por findElement, insertltem y removeElement */ 
    protected Position findPosition(Object key, Position pos){
        if (isExternal(pos)){ 
            if (trace) System.out.println("Nodo externo, return pos "); 
            return pos; // no se encontr clave y se regresa el nodo externo alcanzado 
        }else{ 
            Object curKey = key(pos);
            if (trace){System.out.println("curKey "+curKey+", key "+key);}
            if(C.compare(key, curKey) < 0){ 
                if (trace) System.out.println("Descendemos arbol izquierdo"); 
                return findPosition(key, leftChild(pos));  
            }else  if (C.compare(key, curKey) > 0){      
                        if (trace) System.out.println("Descendemos arbol derecho"); 
                        return findPosition(key, rightChild(pos));
                   }else{
                        if (trace) System.out.println("Igual clave en nodo interno, return pos"); 
                        return pos; 
                   }         
        }   //  else de if (isExternal(pos))
    }
 
    // mtodos definidos en el TDA diccionario 

 
    public Object findElement(Object key) throws InvalidKeyException{
        // checkKey(key); // puede lanzar una InvalidKeyException 
        Position curPos = findPosition(key, root());
        actionPos = curPos; // nodo donde termin la bsqueda 
        if (isInternal(curPos)) 
            return element(curPos);
        else return NO_SUCH_KEY;
    }

    public void insertItem(Object key, Object element) throws InvalidKeyException{ 
        // checkKey(key); // puede lanzar una InvalidException 
        Position insPos = root();
        do{
            insPos = findPosition(key, insPos);
            if(isExternal(insPos))
                break;
            else // la clave ya existe 
                insPos = rightChild(insPos);
        }while (true);
        
        expandExternal(insPos);
        ItemPPR newltem = new ItemPPR(key, element);
        replaceElement(insPos, newltem);
        actionPos = insPos; // nodo donde se insert el artculo nuevo
        if (trace)System.out.println("Expando externo, actualizo nodo pos => "+insPos);
    }

    public Object removeElement(Object key) throws InvalidKeyException{
        Object toReturn;
        // checkKey(key); // puede lanzar una InvalidKeyException 
        Position remPos = findPosition(key, root());
        if(isExternal(remPos)){
            actionPos = remPos; // Bsqueda sin xito 
            return NO_SUCH_KEY;
        }
        else{ 
            toReturn = element(remPos); // elemento a regresar 
            if (isExternal(leftChild(remPos))) 
                remPos = leftChild(remPos);
            else if (isExternal(rightChild(remPos))) 
                remPos = rightChild(remPos);
            else { // la clave est en un nodo con hijos internos
                Position swapPos = remPos; 
                // encontrar un nodo para intercambiar artculos 
                remPos = rightChild(swapPos);
                do
                    remPos = leftChild(remPos);
                while (isInternal(remPos));
                swap(swapPos, parent(remPos));
            }	// cerrando bloque del segundo else
            actionPos = sibling(remPos); // hermano del a quitar 
            removeAboveExternal(remPos);
            return toReturn;
	}	// cerrando bloque del primer else
    }	// Object removeElement
 

    /** Metodos de TDA Dictionary no definidos por el autor
        Suponemos no necesarios en el comportamiento de un arbol
        de busqueda. A los efectos de la compilacion de la clase
        los implementamos con cuerpo nulo                       */
    
    
    public ObjectIterator elements() throws InvalidKeyException{return null;}    
                        // Regresa los elementos guardados en D.
                        //  Entrada: ninguna; Salida: iterador de objetos (elementos).
    public ObjectIterator keys(){return null;}   
                        //  Regresa las claves guardadas en D.
                        //  Entrada: ninguna; Salida: iterador de objetos (claves).
    public ObjectIterator findAllElements(Object k) throws InvalidKeyException{return null;} 
                        //  Regresa un iterador de todos 
                        //  los elementos cuyas claves sean igual a k.
                        //  Entrada: objeto (clave); Salida: iterador (de elementos).
    public ObjectIterator removeAllElements(Object k){return null;} 
                        //  Quita de D a los artculos cuya clave sea igual a k, 
                        //  y regresa un iterador de sus elementos.
                        //  Entrada: objeto (clave); Salida: iterador (de elementos). 
}	// class BinarySearchTree 
