// Author. Tymoschuk, Jorge
public class MyLinkedBinaryTree extends LinkedBinaryTree implements BinaryTree{
    // Atributos de trabajo globales
    boolean trace; int cont, ind;
    Position pos[];
    public MyLinkedBinaryTree(){    //  Constructor
	size  = 1; 
        trace = false;
        cont = ind = 0;
	root  = new BTNode(nuevoObjeto(), null, null, null);
    }

     public void demo(int h){ 
        int niv;
        for(niv = 1; niv <= h; niv++) 
            llenarNivel(root,niv);
        trace = true;
        System.out.println("\nRecorriendo inOrder()");
        inOrder(root);
        System.out.println("\nArbol binario con "+size+" nodos");
    }
    
    public void llenarNivel(Position v, int niv){
        /* Lo primero, guardar en pos[] las posiciones de los nodos externos
           Para ello instanciamos un array de posiciones
           La cantidad de elementos pos a almacenar depende del nivel; como
           debo almacenar los nodos internos u hojas del nivel anterior, 
           la formula es cant = (niv-1)**2, que en java se expresa:     */
        int cant = (int)(Math.pow(2.0, (double)(niv-1)));
        pos = new Position[cant];
        System.out.print("\nPara llenar el nivel "+niv); 
        System.out.println(" instanciamos pos[] con "+cant+" elemento(s)");
        ind = 0;
        positions(root);    //  Almaceno posiciones de los nodos externos
        expandNodos(cant);
    }
    
    public void positions(Position v){
        if(isInternal(v)) positions(leftChild(v)); // recorriendo izquierdo
            if(v != null)   //  si estamos posicionados en un nodo 
                if (isExternal(v)) //  y es externo (Hoja)
                    pos[ind++] = v; //  almaceno su posicion
       if(isInternal(v)) positions(rightChild(v));// Recorriendo derecho
    }

    public void expandNodos(int cant){
        int i;
        for(i=0;i<cant;i++) expandirExterno(pos[i]);
    }
    
    public void expandirExterno (Position v){
        // Expandimos hijo izquierdo 
        ((BTNode) v).setLeft(new BTNode(nuevoObjeto(), 
                                (BTNode) v, null, null));
        size++;
        //  Ahora el derecho
        ((BTNode) v).setRight(new BTNode(nuevoObjeto(),
                                (BTNode) v, null, null));
        size++;
    }

    public ItemPPR nuevoObjeto(){
        Codigo cod; Texto tex; Valor val; ItemPPR it;
        int opcion = (int)(2*Math.random());
        if (opcion == 0){ // Retornaremos un item codigo-valor
            cod = new Codigo(++cont);
            val = new Valor((float)(10*Math.random()));
            it  = new ItemPPR(cod, val);
        }else{          // Retornaremos un item codigo-texto
            cod = new Codigo(++cont);
            tex = new Texto("Text"+(int)(100*Math.random()));
            it  = new ItemPPR(cod, tex);
        }
        System.out.println("Insertando "+it);
        return it;
    }
   
    //  Algoritmos de recorrido
    public void inOrder(Position v){
        if(isInternal(v)) inOrder(leftChild(v)); // recorriendo izquierdo
        if(v != null)   //  si estamos posicionados en un nodo 
            if(trace)
                System.out.println("Visitando..."+v);
        // Visitando el nodo;
        if(isInternal(v)) inOrder(rightChild(v));// Recorriendo derecho
    }
    
    public static void main(String argsd[]){
        int h;      //  altura
        System.out.println("Demo de llenado de Arbol Binario por niveles");
        System.out.println("De que altura desea el Arbol? ");
        h = In.readInt();
        System.out.println("Solicitada altura "+h);
        MyLinkedBinaryTree arBin = new MyLinkedBinaryTree();    //raiz
        arBin.demo(h);
    }
} 